#!/usr/bin/env python2.4

## necessary: otherwise CryptoBoxRootActions.py will refuse to execute this script
PLUGIN_TYPE = "cryptobox"

SHUTDOWN_BIN = "/sbin/shutdown"

## delay (in seconds) before shutdown
SHUTDOWN_DELAY = 3

import subprocess
import sys


def call_prog(progy):
	proc = subprocess.Popen(
	shell = False,
		args = progy)
	proc.communicate()
	return proc.returncode == 0


if __name__ == "__main__":
	args = sys.argv[1:]

	self_bin = sys.argv[0]
	
	if len(args) > 1:
		sys.stderr.write("%s: too many arguments (%s)\n" % (self_bin, args))
		sys.exit(1)
	
	if len(args) == 0:
		sys.stderr.write("%s: no argument supplied\n" % self_bin)
		sys.exit(1)
	
	if args[0] == "reboot":
		result = call_prog([SHUTDOWN_BIN, "-t", str(SHUTDOWN_DELAY), "-r", "now"])
	elif args[0] == "shutdown":
		result = call_prog([SHUTDOWN_BIN, "-t", str(SHUTDOWN_DELAY), "-h", "now"])
	else:
		sys.stderr.write("%s: illegal argument (%s)\n" % (self_bin, args[0]))
		sys.exit(1)
	
	if result:
		sys.exit(0)
	else:
		sys.exit(1)

